/*
 *		BEYCAN KAHRAMAN
 *		040020337
 *		HOMEWORK V
 *		SNAKE GAME
 */

#include <windows.h>										// Header File For Windows
#include <stdio.h>											// Header File For Standard Input / Output
#include <stdarg.h>											// Header File For Variable Argument Routines
#include <gl\gl.h>											// Header File For The OpenGL32 Library
#include <gl\glu.h>											// Header File For The GLu32 Library
#include <gl\glaux.h>										// Header File For The Glaux Library

HDC			hDC=NULL;										// Private GDI Device Context
HGLRC		hRC=NULL;										// Permanent Rendering Context
HWND		hWnd=NULL;										// Holds Our Window Handle
HINSTANCE	hInstance;										// Holds The Instance Of The Application

bool	keys[256];											// Array Used For The Keyboard Routine
bool	ap;													// 'A' Key Pressed?
bool	nextLevel;												// Done Filling In The Grid?
bool	gameover=FALSE;											// Is The Game Over?
bool	anti=TRUE;											// Antialiasing?
bool	active=TRUE;										// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;									// Fullscreen Flag Set To Fullscreen Mode By Default
bool	kazandiniz=FALSE;
bool yeniYedi=FALSE;

int		loop1;												// Generic Loop1

int xBlock = 14;
int yBlock = 12;
int top = 90;
int left = 40;
int xBlockSize = 40;
int yBlockSize = 30;
char puanimiz[20];

int yilanX[200];
int yilanY[200];
int yilanUzunluk = 1;
int yilanYon = 0; // saga
int bekleme = 20;
int sayac = 0;
int ekle = 0;
int yonDegistir = 0;
int yemekX;
int yemekY;
int yemekCesidi;
int puan = 0;

struct			 											// Create A Structure For The Timer Information
{
  __int64       frequency;									// Timer Frequency
  float         resolution;									// Timer Resolution
  unsigned long mm_timer_start;								// Multimedia Timer Start Value
  unsigned long mm_timer_elapsed;							// Multimedia Timer Elapsed Time
  bool			performance_timer;							// Using The Performance Timer?
  __int64       performance_timer_start;					// Performance Timer Start Value
  __int64       performance_timer_elapsed;					// Performance Timer Elapsed Time
} timer;													// Structure Is Named timer

GLuint	texture[2];											// Font Texture Storage Space
GLuint	base;												// Base Display List For The Font

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);		// Declaration For WndProc

void TimerInit(void)										// Initialize Our Timer (Get It Ready)
{
	memset(&timer, 0, sizeof(timer));						// Clear Our Timer Structure

	// Check To See If A Performance Counter Is Available
	// If One Is Available The Timer Frequency Will Be Updated
	if (!QueryPerformanceFrequency((LARGE_INTEGER *) &timer.frequency))
	{
		// No Performace Counter Available
		timer.performance_timer	= FALSE;					// Set Performance Timer To FALSE
		timer.mm_timer_start	= timeGetTime();			// Use timeGetTime() To Get Current Time
		timer.resolution		= 1.0f/1000.0f;				// Set Our Timer Resolution To .001f
		timer.frequency			= 1000;						// Set Our Timer Frequency To 1000
		timer.mm_timer_elapsed	= timer.mm_timer_start;		// Set The Elapsed Time To The Current Time
	}
	else
	{
		// Performance Counter Is Available, Use It Instead Of The Multimedia Timer
		// Get The Current Time And Store It In performance_timer_start
		QueryPerformanceCounter((LARGE_INTEGER *) &timer.performance_timer_start);
		timer.performance_timer			= TRUE;				// Set Performance Timer To TRUE
		// Calculate The Timer Resolution Using The Timer Frequency
		timer.resolution				= (float) (((double)1.0f)/((double)timer.frequency));
		// Set The Elapsed Time To The Current Time
		timer.performance_timer_elapsed	= timer.performance_timer_start;
	}
}

char *getPuan(char* bas, int puanim){
	int len = 0, yedek = puanim;
	strcpy(puanimiz, bas);
	
	while(puanim > 0){
		len++;
		puanim = puanim/10;
	}

	puanim = yedek;

	for(loop1 = len; loop1 >0; loop1--){
		puanimiz[5 + loop1] = '0' + puanim%10;
		puanim = puanim/10;
	}

	puanimiz[strlen(bas) + len] = '\0';

	return puanimiz;
}

float TimerGetTime()										// Get Time In Milliseconds
{
	__int64 time;											// time Will Hold A 64 Bit Integer

	if (timer.performance_timer)							// Are We Using The Performance Timer?
	{
		QueryPerformanceCounter((LARGE_INTEGER *) &time);	// Grab The Current Performance Time
		// Return The Current Time Minus The Start Time Multiplied By The Resolution And 1000 (To Get MS)
		return ( (float) ( time - timer.performance_timer_start) * timer.resolution)*1000.0f;
	}
	else
	{
		// Return The Current Time Minus The Start Time Multiplied By The Resolution And 1000 (To Get MS)
		return( (float) ( timeGetTime() - timer.mm_timer_start) * timer.resolution)*1000.0f;
	}
}

AUX_RGBImageRec *LoadBMP(char *Filename)			        // Loads The Bitmap Images
{
		FILE *File=NULL;								    // File Handle
		if (!Filename)										// Make Sure A Filename Was Given
		{
			return NULL;									// If Not Return NULL
		}
		File=fopen(Filename,"r");							// Check To See If The File Exists
		if (File)											// Does The File Exist?
		{
			fclose(File);									// Close The Handle
			return auxDIBImageLoad(Filename);				// Load The Bitmap And Return A Pointer
		}
		return NULL;										// If Load Failed Return NULL
}

int LoadGLTextures()										// Load Bitmaps And Convert To Textures
{
        int Status=FALSE;									// Status Indicator
        AUX_RGBImageRec *TextureImage[2];					// Create Storage Space For The Textures
        memset(TextureImage,0,sizeof(void *)*2);			// Set The Pointer To NULL

        if ((TextureImage[0]=LoadBMP("Data/Font.bmp")) &&	// Load The Font
			(TextureImage[1]=LoadBMP("Data/Image.bmp")))	// Load Background Image
        {
			Status=TRUE;									// Set The Status To TRUE

			glGenTextures(2, &texture[0]);					// Create The Texture

			for (loop1=0; loop1<2; loop1++)					// Loop Through 2 Textures
			{
				glBindTexture(GL_TEXTURE_2D, texture[loop1]);
				glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[loop1]->sizeX, TextureImage[loop1]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[loop1]->data);
				glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
				glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
			}

			for (loop1=0; loop1<2; loop1++)					// Loop Through 2 Textures
			{
				if (TextureImage[loop1])					// If Texture Exists	
				{
					if (TextureImage[loop1]->data)			// If Texture Image Exists
					{
						free(TextureImage[loop1]->data);	// Free The Texture Image Memory
					}
					free(TextureImage[loop1]);				// Free The Image Structure
				}
			}
		}
	return Status;											// Return The Status
}

GLvoid BuildFont(GLvoid)									// Build Our Font Display List
{
	base=glGenLists(256);									// Creating 256 Display Lists
	glBindTexture(GL_TEXTURE_2D, texture[0]);				// Select Our Font Texture
	for (loop1=0; loop1<256; loop1++)						// Loop Through All 256 Lists
	{
		float cx=float(loop1%16)/16.0f;						// X Position Of Current Character
		float cy=float(loop1/16)/16.0f;						// Y Position Of Current Character

		glNewList(base+loop1,GL_COMPILE);					// Start Building A List
			glBegin(GL_QUADS);								// Use A Quad For Each Character
				glTexCoord2f(cx,1.0f-cy-0.0625f);			// Texture Coord (Bottom Left)
				glVertex2d(0,16);							// Vertex Coord (Bottom Left)
				glTexCoord2f(cx+0.0625f,1.0f-cy-0.0625f);	// Texture Coord (Bottom Right)
				glVertex2i(16,16);							// Vertex Coord (Bottom Right)
				glTexCoord2f(cx+0.0625f,1.0f-cy);			// Texture Coord (Top Right)
				glVertex2i(16,0);							// Vertex Coord (Top Right)
				glTexCoord2f(cx,1.0f-cy);					// Texture Coord (Top Left)
				glVertex2i(0,0);							// Vertex Coord (Top Left)
			glEnd();										// Done Building Our Quad (Character)
			glTranslated(15,0,0);							// Move To The Right Of The Character
		glEndList();										// Done Building The Display List
	}														// Loop Until All 256 Are Built
}

GLvoid KillFont(GLvoid)										// Delete The Font From Memory
{
	glDeleteLists(base,256);								// Delete All 256 Display Lists
}

GLvoid glPrint(GLint x, GLint y, int set, const char *fmt, ...)	// Where The Printing Happens
{
	char		text[256];									// Holds Our String
	va_list		ap;											// Pointer To List Of Arguments

	if (fmt == NULL)										// If There's No Text
		return;												// Do Nothing

	va_start(ap, fmt);										// Parses The String For Variables
	    vsprintf(text, fmt, ap);							// And Converts Symbols To Actual Numbers
	va_end(ap);												// Results Are Stored In Text

	if (set>1)												// Did User Choose An Invalid Character Set?
	{
		set=1;												// If So, Select Set 1 (Italic)
	}
	glEnable(GL_TEXTURE_2D);								// Enable Texture Mapping
	glLoadIdentity();										// Reset The Modelview Matrix
	glTranslated(x,y,0);									// Position The Text (0,0 - Bottom Left)
	glListBase(base-32+(128*set));							// Choose The Font Set (0 or 1)

	if (set==0)												// If Set 0 Is Being Used Enlarge Font
	{
		glScalef(1.5f,2.0f,1.0f);							// Enlarge Font Width And Height
	}

	glCallLists(strlen(text),GL_UNSIGNED_BYTE, text);		// Write The Text To The Screen
	glDisable(GL_TEXTURE_2D);								// Disable Texture Mapping
}

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)			// Resize And Initialize The GL Window
{
	if (height==0)											// Prevent A Divide By Zero By
	{
		height=1;											// Making Height Equal One
	}

	glViewport(0,0,width,height);							// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);							// Select The Projection Matrix
	glLoadIdentity();										// Reset The Projection Matrix

	glOrtho(0.0f,width,height,0.0f,-1.0f,1.0f);				// Create Ortho 640x480 View (0,0 At Top Left)
	glMatrixMode(GL_MODELVIEW);								// Select The Modelview Matrix
	glLoadIdentity();	
}

int InitGL(GLvoid)											// All Setup For OpenGL Goes Here
{
	if (!LoadGLTextures())									// Jump To Texture Loading Routine
	{
		return FALSE;										// If Texture Didn't Load Return FALSE
	}
	BuildFont();											// Build The Font

	glShadeModel(GL_SMOOTH);								// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);					// Black Background
	glClearDepth(1.0f);										// Depth Buffer Setup
	glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);					// Set Line Antialiasing
	glEnable(GL_BLEND);										// Enable Blending
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	yilanX[0] = 6;
	yilanY[0] = 5;
	srand(1453);
	yemekX = rand()%(xBlock);
	yemekY = rand()%(yBlock);
	yemekCesidi = rand()%3;
	return TRUE;											// Initialization Went OK
}

int DrawGLScene(GLvoid)										// Here's Where We Do All The Drawing
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);		// Clear Screen And Depth Buffer
	glBindTexture(GL_TEXTURE_2D, texture[0]);				// Select Our Font Texture
	glColor3f(1.0f,0.5f,1.0f);
	glPrint(247,10,0,"SNAKE GAME");
	glColor3f(0.8f,0.0f,0.0f);
	glPrint(200,40,0,"beycan kahraman");

	glColor3ub(255, 255, 0);		// Pick A Random Color
	glPrint(40,20,1,getPuan("SCORE: ", puan));
	glPrint(40,50,1,getPuan("SPEED: ", 21-bekleme));

	if (kazandiniz)											// Is The Game Over?
	{
		glColor3ub(rand()%255,rand()%255,rand()%255);		// Pick A Random Color
		glPrint(230,55,1,"CONGRATULATIONS!");						// Write BITTI To The Screen
		glPrint(250,70,1,"PRESS SPACE");					// Write PRESS SPACE To The Screen
	}
	else if (gameover)											// Is The Game Over?
	{
		glColor3ub(rand()%255,rand()%255,rand()%255);		// Pick A Random Color
		glPrint(260,55,1,"GAME OVER");						// Write GAME OVER To The Screen
		glPrint(250,70,1,"PRESS SPACE");					// Write PRESS SPACE To The Screen
	}else{
		if(sayac % bekleme == 0){
			yeniYedi = FALSE;
			if(yonDegistir > 0){
				yilanYon = yonDegistir-1;
				yonDegistir = 0;
			}

			if(ekle == 1){
				yilanUzunluk++;
				ekle = 0;

				if(puan%10 == 0 && bekleme > 3){
					bekleme--;
					PlaySound("Data/freeze.wav", NULL, SND_ASYNC | SND_LOOP);
				}
			}

			for (loop1=yilanUzunluk-1; loop1>0; loop1--){
				yilanX[loop1] = yilanX[loop1-1];
				yilanY[loop1] = yilanY[loop1-1];
			}

			if(yilanYon == 0){
				yilanX[0] = (yilanX[0] + 1)%xBlock;
			}else if(yilanYon == 1){
				yilanY[0] = (yilanY[0] + yBlock - 1)%yBlock;
			}else if(yilanYon == 2){
				yilanX[0] = (yilanX[0] + xBlock - 1)%xBlock;
			}else{
				yilanY[0] = (yilanY[0] + 1)%yBlock;
			}

			if(yemekX == yilanX[0] && yemekY == yilanY[0]){
				yeniYedi = TRUE;
				puan++;
				ekle = 5;
				PlaySound("Data/hourglass.wav", NULL, SND_ASYNC);
				while(ekle != 1){
					ekle = 1;
					yemekX = rand()%(xBlock);
					yemekY = rand()%(yBlock);
					yemekCesidi = rand()%3;

					for(loop1=0; loop1<yilanUzunluk; loop1++){
						if(yemekX == yilanX[loop1] && yemekY == yilanY[loop1]){
							ekle = 5;
							break;
						}
					}
				}
			}

			for (loop1=1; loop1<yilanUzunluk; loop1++){
				if(yilanX[0] == yilanX[loop1] && yilanY[0] == yilanY[loop1]){
					gameover = TRUE;
					PlaySound("Data/Die.wav", NULL, SND_SYNC);
				}
			}

			if(yilanUzunluk > yBlock*xBlock-2 && !kazandiniz){
				PlaySound("Data/Complete.wav", NULL, SND_SYNC);
				kazandiniz = TRUE;
			}
		}

		sayac = (sayac + 1)%bekleme;
	}

		for (loop1=0; loop1<yBlock+1; loop1++)					// Loop Through Lives Minus Current Life
		{
			glLoadIdentity();
			if(loop1%2 == 1)
				glColor3f(0.4f,0.4f,0.4f);
			else
				glColor3f(0.5f,0.5f,0.5f);						// Set Player Color To Light Green
			glBegin(GL_LINES);									// Start Drawing Our Player Using Lines
				glVertex2d(left, top + loop1*yBlockSize);
				glVertex2d(left + xBlock*xBlockSize, top + loop1*yBlockSize);
			glEnd();
		}
		for (loop1=0; loop1<xBlock+1; loop1++)					// Loop Through Lives Minus Current Life
		{
			glLoadIdentity();
			if(loop1%2 == 1)
				glColor3f(0.4f,0.4f,0.4f);
			else
				glColor3f(0.5f,0.5f,0.5f);
			glBegin(GL_LINES);									// Start Drawing Our Player Using Lines
				glVertex2d(left + loop1*xBlockSize, top);
				glVertex2d(left + loop1*xBlockSize, top + yBlock*yBlockSize);
			glEnd();
		}

		
		for (loop1=yilanUzunluk-1; loop1>=0; loop1--)					// Loop Through Lives Minus Current Life
		{
			glLoadIdentity();
			glColor3f(0.7f,0.5f,0.0f);
			if(loop1 == 0)
				glColor3f(0.7f,0.0f,0.0f);

			glEnable(GL_TEXTURE_2D);						// Enable Texture Mapping
			glColor3f(1.0f,1.0f,1.0f);						// Bright White Color
			glBindTexture(GL_TEXTURE_2D, texture[1]);		// Select The Tile Image

					glBegin(GL_QUADS);						// Draw A Textured Quad
					if(loop1 == 0 && yeniYedi){
						glTexCoord2f(0.0f, 0.66f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.33f, 0.66f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.33f, 0.99f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*(yilanY[loop1]+1)-1);
						glTexCoord2f(0.0f, 0.99f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*(yilanY[loop1]+1)-1);
					}else if(loop1 == 0 && yilanYon == 0){
						glTexCoord2f(0.0f, 0.0f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.33f, 0.0f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.33f, 0.33f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*(yilanY[loop1]+1)-1);
						glTexCoord2f(0.0f, 0.33f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*(yilanY[loop1]+1)-1);
					}else if(loop1 == 0 && yilanYon == 1){
						glTexCoord2f(0.33f, 0.0f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.66f, 0.0f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.66f, 0.33f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*(yilanY[loop1]+1)-1);
						glTexCoord2f(0.33f, 0.33f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*(yilanY[loop1]+1)-1);
					}else if(loop1 == 0 && yilanYon == 2){
						glTexCoord2f(0.66f, 0.0f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.99f, 0.0f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.99f, 0.33f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*(yilanY[loop1]+1)-1);
						glTexCoord2f(0.66f, 0.33f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*(yilanY[loop1]+1)-1);
					}else if(loop1 == 0 && yilanYon == 3){
						glTexCoord2f(0.0f, 0.33f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.33f, 0.33f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.33f, 0.66f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*(yilanY[loop1]+1)-1);
						glTexCoord2f(0.0f, 0.66f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*(yilanY[loop1]+1)-1);
					}else{
						glTexCoord2f(0.33f, 0.33f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.66f, 0.33f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*yilanY[loop1]);
						glTexCoord2f(0.66f, 0.66f);
						glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*(yilanY[loop1]+1)-1);
						glTexCoord2f(0.33f, 0.66f);
						glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*(yilanY[loop1]+1)-1);
					}
					glEnd();								// Done Texturing The Box

			/*
			glBegin(GL_QUADS);
				glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*yilanY[loop1]);
				glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*yilanY[loop1]);
				glVertex2d(left + xBlockSize*(yilanX[loop1]+1), top + yBlockSize*(yilanY[loop1]+1)-1);
				glVertex2d(left + xBlockSize*yilanX[loop1]+1, top + yBlockSize*(yilanY[loop1]+1)-1);
			glEnd();*/
		}
		

			glLoadIdentity();							// Set Player Color To Light Green
			glBegin(GL_QUADS);									// Start Drawing Our Player Using Lines
			if(yemekCesidi == 0){
				glTexCoord2f(0.66f, 0.33f);
				glVertex2d(left + xBlockSize*yemekX+1, top + yBlockSize*yemekY);
				glTexCoord2f(0.99f, 0.33f);
				glVertex2d(left + xBlockSize*(yemekX+1), top + yBlockSize*yemekY);
				glTexCoord2f(0.99f, 0.66f);
				glVertex2d(left + xBlockSize*(yemekX+1), top + yBlockSize*(yemekY+1)-1);
				glTexCoord2f(0.66f, 0.66f);
				glVertex2d(left + xBlockSize*yemekX+1, top + yBlockSize*(yemekY+1)-1);
			}else if(yemekCesidi == 1){
				glTexCoord2f(0.66f, 0.66f);
				glVertex2d(left + xBlockSize*yemekX+1, top + yBlockSize*yemekY);
				glTexCoord2f(0.99f, 0.66f);
				glVertex2d(left + xBlockSize*(yemekX+1), top + yBlockSize*yemekY);
				glTexCoord2f(0.99f, 0.99f);
				glVertex2d(left + xBlockSize*(yemekX+1), top + yBlockSize*(yemekY+1)-1);
				glTexCoord2f(0.66f, 0.99f);
				glVertex2d(left + xBlockSize*yemekX+1, top + yBlockSize*(yemekY+1)-1);
			}else{
				glTexCoord2f(0.33f, 0.66f);
				glVertex2d(left + xBlockSize*yemekX+1, top + yBlockSize*yemekY);
				glTexCoord2f(0.66f, 0.66f);
				glVertex2d(left + xBlockSize*(yemekX+1), top + yBlockSize*yemekY);
				glTexCoord2f(0.66f, 0.99f);
				glVertex2d(left + xBlockSize*(yemekX+1), top + yBlockSize*(yemekY+1)-1);
				glTexCoord2f(0.33f, 0.99f);
				glVertex2d(left + xBlockSize*yemekX+1, top + yBlockSize*(yemekY+1)-1);
			}
			glEnd();

		glDisable(GL_TEXTURE_2D);

	return TRUE;											// Everything Went OK
}

GLvoid KillGLWindow(GLvoid)									// Properly Kill The Window
{
	if (fullscreen)											// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);						// If So Switch Back To The Desktop
		ShowCursor(TRUE);									// Show Mouse Pointer
	}

	if (hRC)												// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))						// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))							// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;											// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))						// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;											// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))						// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;											// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))				// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;										// Set hInstance To NULL
	}

	KillFont();												// Kill The Font We Built
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;									// Holds The Results After Searching For A Match
	WNDCLASS	wc;												// Windows Class Structure
	DWORD		dwExStyle;										// Window Extended Style
	DWORD		dwStyle;										// Window Style
	RECT		WindowRect;										// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;									// Set Left Value To 0
	WindowRect.right=(long)width;								// Set Right Value To Requested Width
	WindowRect.top=(long)0;										// Set Top Value To 0
	WindowRect.bottom=(long)height;								// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;									// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;								// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);	// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,						// Extended Style For The Window
								"OpenGL",						// Class Name
								title,							// Window Title
								dwStyle |						// Defined Window Style
								WS_CLIPSIBLINGS |				// Required Window Style
								WS_CLIPCHILDREN,				// Required Window Style
								0, 0,							// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,							// No Parent Window
								NULL,							// No Menu
								hInstance,						// Instance
								NULL)))							// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=							// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),							// Size Of This Pixel Format Descriptor
		1,														// Version Number
		PFD_DRAW_TO_WINDOW |									// Format Must Support Window
		PFD_SUPPORT_OPENGL |									// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,										// Must Support Double Buffering
		PFD_TYPE_RGBA,											// Request An RGBA Format
		bits,													// Select Our Color Depth
		0, 0, 0, 0, 0, 0,										// Color Bits Ignored
		0,														// No Alpha Buffer
		0,														// Shift Bit Ignored
		0,														// No Accumulation Buffer
		0, 0, 0, 0,												// Accumulation Bits Ignored
		16,														// 16Bit Z-Buffer (Depth Buffer)  
		0,														// No Stencil Buffer
		0,														// No Auxiliary Buffer
		PFD_MAIN_PLANE,											// Main Drawing Layer
		0,														// Reserved
		0, 0, 0													// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))										// Did We Get A Device Context?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))				// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))					// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))							// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}	

	if(!wglMakeCurrent(hDC,hRC))								// Try To Activate The Rendering Context
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);									// Show The Window
	SetForegroundWindow(hWnd);									// Slightly Higher Priority
	SetFocus(hWnd);												// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);								// Set Up Our Perspective GL Screen

	if (!InitGL())												// Initialize Our Newly Created GL Window
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	return TRUE;												// Success
}

LRESULT CALLBACK WndProc(	HWND	hWnd,						// Handle For This Window
							UINT	uMsg,						// Message For This Window
							WPARAM	wParam,						// Additional Message Information
							LPARAM	lParam)						// Additional Message Information
{
	switch (uMsg)												// Check For Windows Messages
	{
		case WM_ACTIVATE:										// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))								// Check Minimization State
			{
				active=TRUE;									// Program Is Active
			}
			else												// Otherwise
			{
				active=FALSE;									// Program Is No Longer Active
			}

			return 0;											// Return To The Message Loop
		}

		case WM_SYSCOMMAND:										// Intercept System Commands
		{
			switch (wParam)										// Check System Calls
			{
				case SC_SCREENSAVE:								// Screensaver Trying To Start?
				case SC_MONITORPOWER:							// Monitor Trying To Enter Powersave?
				return 0;										// Prevent From Happening
			}
			break;												// Exit
		}

		case WM_CLOSE:											// Did We Receive A Close Message?
		{
			PostQuitMessage(0);									// Send A Quit Message
			return 0;											// Jump Back
		}

		case WM_KEYDOWN:										// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;								// If So, Mark It As TRUE
			return 0;											// Jump Back
		}

		case WM_KEYUP:											// Has A Key Been Released?
		{
			keys[wParam] = FALSE;								// If So, Mark It As FALSE
			return 0;											// Jump Back
		}

		case WM_SIZE:											// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));		// LoWord=Width, HiWord=Height
			return 0;											// Jump Back
		}
	}

	return DefWindowProc(hWnd,uMsg,wParam,lParam);				// Pass All Unhandled Messages To DefWindowProc
}

int WINAPI WinMain(	HINSTANCE	hInstance,						// Instance
					HINSTANCE	hPrevInstance,					// Previous Instance
					LPSTR		lpCmdLine,						// Command Line Parameters
					int			nCmdShow)						// Window Show State
{
	MSG		msg;												// Windows Message Structure
	BOOL	done=FALSE;											// Bool Variable To Exit Loop

	// Ask The User Which Screen Mode They Prefer
	//if (MessageBox(NULL,"Would You Like To Run In Fullscreen Mode?", "Start FullScreen?",MB_YESNO|MB_ICONQUESTION)==IDNO)
	//{
	//	fullscreen=FALSE;										// Windowed Mode
	//}

	// Create Our OpenGL Window
	if (!CreateGLWindow("NeHe's Line Tutorial",640,480,16,fullscreen))
	{
		return 0;												// Quit If Window Was Not Created
	}

	TimerInit();

	while(!done)												// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))				// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)							// Have We Received A Quit Message?
			{
				done=TRUE;										// If So done=TRUE
			}
			else												// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);							// Translate The Message
				DispatchMessage(&msg);							// Dispatch The Message
			}
		}
		else													// If There Are No Messages
		{
			float start=TimerGetTime();							// Grab Timer Value Before We Draw
			
			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if ((active && !DrawGLScene()) || keys[VK_ESCAPE])	// Active?  Was There A Quit Received?
			{
				done=TRUE;										// ESC or DrawGLScene Signalled A Quit
			}
			else												// Not Time To Quit, Update Screen
			{
				SwapBuffers(hDC);								// Swap Buffers (Double Buffering)
			}

			while(TimerGetTime()<start+float(10.0f)) {}	// Waste Cycles On Fast Systems

			if (keys[VK_F1])									// Is F1 Being Pressed?
			{
				keys[VK_F1]=FALSE;								// If So Make Key FALSE
				KillGLWindow();									// Kill Our Current Window
				fullscreen=!fullscreen;							// Toggle Fullscreen / Windowed Mode
				// Recreate Our OpenGL Window
				if (!CreateGLWindow("NeHe's Line Tutorial",640,480,16,fullscreen))
				{
					return 0;									// Quit If Window Was Not Created
				}
			}

			if (keys['A'] && !ap)								// If 'A' Key Is Pressed And Not Held
			{
				ap=TRUE;										// ap Becomes TRUE
				anti=!anti;										// Toggle Antialiasing
			}
			if (!keys['A'])										// If 'A' Key Has Been Released
			{
				ap=FALSE;										// ap Becomes FALSE
			}

			if (keys[VK_RIGHT] && yilanYon!=2)
				yonDegistir = 1;
			else if(keys[VK_UP] && yilanYon!=3)
				yonDegistir = 2;
			else if(keys[VK_LEFT] && yilanYon!=0)
				yonDegistir = 3;
			else if(keys[VK_DOWN] && yilanYon!=1)
				yonDegistir = 4;


			if (!gameover && active)							// If Game Isn't Over And Programs Active Move Objects
			{
				
			}
			else												// Otherwise
			{
				if (keys[' '])									// If Spacebar Is Being Pressed
				{
					gameover=FALSE;
					kazandiniz = FALSE;
					yilanX[0] = 6;
					yilanY[0] = 5;
					yilanUzunluk = 1;
					yilanYon = 0;
					yonDegistir = 0;
					ekle = 0;
					srand(1453);
					yemekX = rand()%(xBlock);
					yemekY = rand()%(yBlock);
					yemekCesidi = rand()%3;
					puan = 0;
					bekleme = 20;
					sayac = 0;
					yeniYedi=FALSE;
				}
			}

			if (nextLevel)											// Is The Grid Filled In?
			{
			
			}
		}
	}

	// Shutdown
	KillGLWindow();												// Kill The Window
	return (msg.wParam);										// Exit The Program
}
